<?php defined('ZEN_ALLOW') or die();

/* =====================================================================
Template:	Xero - Base theme for the Zen Grid Framework v4.
Author: 	Anthony Olsen Joomlabamboo
Version: 	1.0
Created: 	August 2014
Copyright:	Anthony Olsen - (C) 2014 - All rights reserved
/* ===================================================================== */

	
// Determines the layout type to use.
// Cant use the standard spotlight function because we need to 
// Source order the columns here so main content is always on top
// When collapsed.

// Get mainlayout 
// layout_type / rendered_layout / sidebar1 / sidebar2 / source_ordered

$main_layout = $this->getMainLayout($this->layout->main->positions);
$source_order=$main_layout['source_order'];

if($source_order) {

	$sidebar1=$main_layout['sidebar1'];
	$sidebar2=$main_layout['sidebar2'];
	$sidebar1_offset="";
	$sidebar2_offset="";
	$main_offset="";
	$layout_type=$main_layout['layout'];
	$main_layout = $this->layout->main->positions;
	
	// Set the value for the layout
	if($sidebar1 + $sidebar2 == 0) {
		$layout = 'fullwidth';
	}
	elseif ($sidebar1 && !$sidebar2) {
		$layout = 'sidebar1_layout_only';
	} elseif (!$sidebar1 && $sidebar2) {
		$layout = 'sidebar2_layout_only';
	} else {
		$layout = '3columns';
	}

	
	if($layout_type=="lmr") {
		
		if($layout =="3columns") {
			$sidebar1_offset = "zen-pull zen-pull-".$main_layout->maincontent;
			$main_offset = "zen-push zen-push-". ($main_layout->sidebar1);
			echo '';
		}
		elseif($layout =="sidebar1_layout_only") {
			$main_layout->maincontent = $main_layout->maincontent + $main_layout->sidebar2;
			$sidebar1_offset = "zen-pull zen-pull-".$main_layout->maincontent;
			$main_offset = "zen-push zen-push-". ($main_layout->sidebar1);
		}
		elseif($layout =="sidebar2_layout_only") {
		
			$main_layout->maincontent = $main_layout->maincontent + $main_layout->sidebar1;
		}
					
	} elseif($layout_type=="rm") {
	
		if($sidebar2) {
			$sidebar2_offset = "zen-pull zen-pull-".($main_layout->maincontent);
			$main_offset = "zen-push zen-push-". ($main_layout->sidebar2);
		}
		else {
			
		}
	} elseif($layout_type=="lrm" || $layout_type=="rml") {
	
		if($sidebar1 && $sidebar2) {
			$sidebar2_offset = "zen-pull zen-pull-".$main_layout->maincontent;
			$main_offset = $main_layout->sidebar1 + $main_layout->sidebar2;
			$main_offset = "zen-push zen-push-".$main_offset;
			$sidebar1_offset= "zen-pull zen-pull-".$main_layout->maincontent;
		}
		elseif($sidebar1) {
			$main_offset = $main_layout->sidebar1;
			$main_offset = "zen-push zen-push-".$main_offset;
			$main_layout->maincontent = $main_layout->maincontent + $main_layout->sidebar2;
			$sidebar1_offset = "zen-pull zen-pull-".$main_layout->maincontent;
		}
		elseif($sidebar2) {
			$main_offset = $main_layout->sidebar2;
			$main_offset = "zen-push zen-push-".$main_offset;
			$main_layout->maincontent = $main_layout->maincontent + $main_layout->sidebar1;
			$sidebar2_offset = "zen-pull zen-pull-".$main_layout->maincontent;
		}
	} elseif($layout_type=="mlr" or $layout_type=="mrl") {
		
		if(!$sidebar1) {
			$main_layout->maincontent = $main_layout->maincontent + $main_layout->sidebar1;
		} elseif(!$sidebar2)  {
			$main_layout->maincontent = $main_layout->maincontent + $main_layout->sidebar2;
		}
	
	}
	
	$midcol = 1;
	if(!isset($main_layout->maincontent)) {
		$midcol = 0;
	}
} 
?>
<?php if($this->checkSpotlight('main')) {

if(!isset($this->theme->{'main-row-parallax'})) {
	$this->theme->{'main-row-parallax'} = 0;
}
?>
<!-- MAIN CONTENT -->
<section id="mainwrap" class="zen-row-wrap clearfix <?php echo $this->rowClass('main');?>"<?php if($this->theme->{'main-row-parallax'}) {?> data-speed="<?php echo $this->theme->{'main-p_speed'};?>" style="background-attachment: fixed;background-size:<?php echo $this->theme->{'main-p_imagesize'};?>" data-type="background"<?php } ?>>
	<a id="main-link" name="main-link"></a>
	
	
	<?php if($this->checkSpotlight('above')) { ?>
	<section id="abovewrap" class="clearfix <?php echo $this->rowClass('above');?>">
		<div class="zen-container">
			<div class="zen-row">
				<div class="zen-spotlight">
				
					<!-- Banner-slogan -->
					<div id="above" class="zg-col zg-col-12">
						 <?php $this->loadModule('above');?>
					</div>
					<!-- //breadcrumb -->
				</div>
			</div>
		</div>
	</section>
	<?php } ?>
	
	<div class="zen-container">
		<div class="zen-row">
			
				<?php if(!$source_order) {
					$this->getModules('main');
				} else { ?>
					<div class="mainwrap zen-spotlight">
					<?php if($midcol) {?>
					<div id="midCol" class="zg-col zg-col-<?php echo $main_layout->maincontent;?> <?php echo $main_offset;?>">
						<?php $this->loadblock('main-content');?>
					</div>
					<?php } ?>
					<?php if($sidebar1) { ?>
					<div id="sidebar-1" class="sidebar zg-col zg-col-<?php echo $main_layout->sidebar1;?> <?php echo $sidebar1_offset;?>" role="complementary">
						<jdoc:include type="modules" name="sidebar1" style="zendefault" />
					
					</div>
					<?php } ?>
					<?php if($sidebar2) {?>
					<div id="sidebar-2" class="sidebar zg-col zg-col-<?php echo $main_layout->sidebar2;?>  <?php echo $sidebar2_offset;?>" role="complementary">
						<jdoc:include type="modules" name="sidebar2" style="zendefault" />
					</div>
					<?php } ?>
					</div>
				<?php }?>
			
		</div>
	</div>
	
	<?php if($this->checkSpotlight('below')) { ?>
	<section id="belowwrap" class="clearfix">
		<div class="zen-container">
			<div class="zen-row">
				<div class="zen-spotlight">
				
					<!-- Banner-slogan -->
					<div id="below" class="zg-col zg-col-12">
						  <?php $this->loadModule('below');?>
					</div>
					<!-- //breadcrumb -->
				</div>
			</div>
		</div>
	</section>
	<?php } ?>
</section>
<?php } ?>