<?php defined('ZEN_ALLOW') or die();

/* =====================================================================
Template:	Xero - Base theme for the Zen Grid Framework v4.
Author: 	Anthony Olsen Joomlabamboo
Version: 	1.0
Created: 	August 2014
Copyright:	Anthony Olsen - (C) 2014 - All rights reserved
/* ===================================================================== */


?>
<div class="zen-row">
	<div class="zen-spotlight">
	
	<?php 
			
			// Used to count the number of items that the user
			// Has published in the layout tool.
			// We compare that later on to see if we should honour the layout tool
			// Otherwise we end up with empty space in the layout.
			// Loop through the modules to see all modules that are listed are published
			
			$equalcols = 0;
			$i = 0;
			$gridprefix = 'zg-col zg-col-';
			$equalise_columns = $this->params->force_equal;
			
			foreach ($modules as $module => $width) {
				
				$published = ($this->countModules($module)?1:0);
				
				$spacer_search = substr($module, 0, 6);
				
				if($spacer_search == "spacer") {
					$module = "spacer";
				}
				
				// We cant count the following items as being published so we just flag that straight away
				// as being published
				if($module == 'maincontent') {
					$published = 1;
				}
				
				elseif($module == 'social') {
					$published = 1;
				}

				elseif($module == 'social-mobile') {
					$published = 1;
				}
				
				elseif($module == 'select-menu') {
					$published = 1;
				}
				
				elseif($module == 'toggle-menu') {
					$published = 1;
				}
							
				elseif($module == 'one-page-menu') {
				
					$published = 1;
				}
				
				elseif($module == 'off-canvas-trigger') {
					$published = 1;
				}
				
				elseif($module == 'off-canvas-trigger-mobile') {
					$published = 1;
				}
				
				elseif($module == 'panel-trigger') {
					$published = 1;
				}
				
				elseif($module == 'spacer') {
				
					$published = 1;
				}

				if(!$published) {
					
					// Check to see if we should equalise the columns
					// if not all modules are published on a specific page
					if($equalise_columns) {
						$equalcols = 1;
					}
					
				} else {
					$i = $i + 1;
				}
			}

		if($i) {
			foreach ($modules as $module => $width) {
				
				if($equalcols) {
					$width = 12 / $i;
				}
				
				if($this->params->print_settings) {
					echo '<span class="debug-module-name" style="position: absolute;
					background: red;
					color: #fff;
					padding: 4px;
					border-radius: 2px;">'.$module.'</span>';
				}
				$spacer_search = substr($module, 0, 6);
				
				if($spacer_search == "spacer") {
					$module = "spacer";
				}
				
				// Check to see if it's a spacer
				
				if($module == 'menu') { ?>
				
					<div id="menu-wrap" class="<?php echo $gridprefix;?><?php echo $width;?>">
					
					<?php $this->loadBlock('menu-content'); ?>
					
					</div>
				<?php }
				
				elseif($module == 'select-menu') { ?>
				
					<div id="mobile-menu-wrap" class="visible-navcollapse <?php echo $gridprefix;?><?php echo $width;?>">
					
					<?php $this->loadBlock('select-menu'); ?>
					
					</div>
				<?php }
				
				elseif($module == 'toggle-menu') { ?>
				
					<div id="mobile-menu-wrap" class="visible-navcollapse <?php echo $gridprefix;?><?php echo $width;?>">
					
					<?php $this->loadBlock('toggle-menu'); ?>
					
					</div>
				<?php }
				
				elseif($module == 'one-page-menu') { ?>
				
					<div id="one-page-menu-wrap" class="<?php echo $gridprefix;?><?php echo $width;?>">
					
					<?php $this->loadBlock('one-page-menu'); ?>
					
					</div>
				<?php }
				
				elseif($module == 'maincontent') { ?>
					
					<div id="midCol" class="<?php echo $gridprefix;?><?php echo $width;?>">
					
						<?php $this->loadBlock('main-content'); ?>
					
					</div>
			
				<?php }
				
				elseif($module == 'spacer') { ?>
						
						<div class="zg-spacer hidden-phone <?php echo $gridprefix;?><?php echo $width;?>">
						
							<?php $this->loadBlock('spacer'); ?>
						
						</div>
				
					<?php }
				
				elseif($module == 'off-canvas-trigger') { ?>
					<div class="offcanvas-trigger <?php echo $gridprefix;?><?php echo $width;?>">	
						<?php $this->loadBlock('off-canvas-trigger'); ?>
					</div>
				<?php }
				
				elseif($module == 'off-canvas-trigger-mobile') { ?>
					<div class="offcanvas-trigger <?php echo $gridprefix;?><?php echo $width;?>">	
						<?php $this->loadBlock('off-canvas-trigger-mobile'); ?>
					</div>
				<?php }
				
				
				elseif($module == 'panel-trigger') { ?>
					<div class="panel-trigger <?php echo $gridprefix;?><?php echo $width;?>">	
						<?php $this->loadBlock('panel-trigger'); ?>
					</div>
				<?php 
				}
				
				elseif($module == 'social') { ?>
				
					<div class="social-wrap zg-<?php echo $this->params->social_position;?> <?php echo $this->params->social_position_align;?> <?php echo $this->params->social_style;?> <?php echo $gridprefix;?><?php echo $width;?>">	
						<?php $this->loadBlock('social'); ?>
					</div>
									
				<?php }
				
				elseif($module == 'social-mobile') { ?>
				
					<div class="social-wrap social-mobile  zg-<?php echo $this->params->social_mobile_position;?> <?php echo $this->params->social_mobile_position_align;?> <?php echo $this->params->social_mobile_style;?> <?php echo $gridprefix;?><?php echo $width;?>">	
						<?php $this->loadBlock('social-mobile'); ?>
					</div>
									
				<?php } else {
			
				if ($this->countModules($module)) : ?>
	
					<div id="<?php echo $module;?>" class="<?php echo $gridprefix;?><?php echo $width;?>">
		
						<?php echo $this->loadModule($module);?>
	
					</div>
	
				<?php endif;
				}
			} 
		}?>
	</div>
</div>