(function ($) {
		
		$.fn.set_theme_data = function (template, time, theme_path) {

			var theme = $('#cssfile').val();
				theme = 'theme.' + theme;
				
				// Check to see if using a preset
				var is_preset = theme.indexOf('[example]');
				
				if(is_preset > 1) {
					// Replace the first instacne of theme
					// So we get the correct path to the file.
					theme = theme.replace('theme.', '');
					
					// Makse sure the css is processed
					$('#cssfile').addClass('updated');
				}
				
			var clean_theme = theme.replace('presets/theme.[example]-', '');
				clean_theme = clean_theme.replace('theme.','');
				
			// Set the name of the save style input
			$('#style-name').val(clean_theme);
			
			var new_theme_exists = $("#cssfile option[value='"+clean_theme +"']").length;
				
			if(new_theme_exists < 1) {
	
			  	// Append the new preset to the presetlist
			   	$('select#cssfile').append($('<option>', {
			   	 	    value: clean_theme,
			   	 	    text: clean_theme,
			   	 	    selected: 1
			   	}));
			   	
			   	$('#cssfile').addClass('updated');
			   	$('#compile_required').val('1');
			}
					
					
			$('#cssfile').val(clean_theme);
		
		
		// Check json before continuing.
		// Might take a little longer but is better to check if the json is correct
		
	
		
		$.getJSON('../' + theme_path + 'settings/themes/' + theme + '.json?v=' + time, function() {})
		
		.success(function(data) { 
				
				
				// Reset items to default value when changing themes.
			$('.side-drawer').find('input:not(select)').each(function() {
			
				var target = $(this).attr('data-compile');
				
				if(target !=="config") {
				
					// See if it's got a default value
					var data_default = $(this).attr('data-default');
					var id = $(this).attr('id');
					
					if(id !=="style-name") {
						if(typeof data_default !=="undefined") {
							$(this).val(data_default);
						} else {
							$(this).val('');
						}
					}
				}
			});
			
			
				// We have to revert it back to the old way because there is no way to update old themes to the new format until the user saves them.
				
	     	 if(data.settings) {
	     	 
	     	 	var flattenObject = function(ob) {
	     	 	 	var toReturn = {};
	     	 	 	
	     	 	 	for (var i in ob) {
	     	 	 		if (!ob.hasOwnProperty(i)) continue;
	     	 	 		
	     	 	 		if ((typeof ob[i]) == 'object') {
	     	 	 			var flatObject = flattenObject(ob[i]);
	     	 	 			for (var x in flatObject) {
	     	 	 				if (!flatObject.hasOwnProperty(x)) continue;
	     	 	 				
	     	 	 				toReturn[x] = flatObject[x];
	     	 	 			}
	     	 	 		} else {
	     	 	 			toReturn[i] = ob[i];
	     	 	 		}
	     	 	 	}
	     	 	 	return toReturn;
	     	 	 };
	     	 		
	     	 	
	     	 	
	     	 	// Set data object
	     	 	data = flattenObject(data);

	     	 }
	     	 
	     
	     	// Parse through the json object and populate fields
			$.each( data, function( key, val ) {
	     	    	
	     	    	var target = '#' + key;
	     	    	
	     	    	// Remove leading #
	     	    	val = val.replace('#', '');
	     	    	
	     	    	// If its an image file name we remove the folder name
	     	    	
	     	    	val = val.replace(/\'..\/..\/../g, '').replace(/'/g, '');
	     	    	
	     	    	
	     	    	     	    	
	     	    	// Set the value if its not null
	     	    	if(val!=="") {
	   
	     	    		$(target).not('[data-compile="layout"]').val(val).attr('data-stored', val);
	     	    		
	     	    	}
	     	    	
	     	    	// Colors
	     	    	if($(target).hasClass('zt-picker')) {
	     	    	
	     	    		if(val == "") {
	     	    			val= $(target).attr('data-default')
	     	    		}
	     	    		
	     	    		$(target).css({'border-color': '#' + val});
	     	    		
	     	    		var firstletter = val.charAt(0);
	     	    		
	     	    		if(firstletter == "@") {
	     	    			var other = val.substring(1, val.length);
	     	    			
	     	    			other = $('input#' + other).val();
	     	    			
	     	    				$(target).css({'border-right-color': '#' + other});
	     	    		}
	     	    		
	     	    		
	     	    		var firstletter = val.substring(0, 3);
	     	    		
	     	    		if(firstletter == "dar" || firstletter == "lig") {
	     	    			
	     	    			
	     	    			if(firstletter == "dar") {
	     	    				var other = val.substring(8, val.length);
	     	    				other = other.split(',');
	     	    			}
	     	    			
	     	    			
	     	    			if(firstletter == "lig") {
	     	    				var other = val.substring(9, val.length);
	     	    				other = other.split(',');
	     	    			}
	     	    			
	     	    			
	     	    			// Change % into a decimal    				
	     	    			var percentage = other[1].slice(0,-2);
	     	    				percentage = parseFloat(percentage) / 100.0;
	     	    				
	     	    				if(firstletter == "dar") {
	     	    					percentage = '-' + percentage;
	     	    				}
	     	    			
	     	    				
	     	    				other = other[0];
	     	    				other = $('input#' + other).val();
	     	    				
	     	    				var newColor = $(document).ColorLuminance(other, percentage); 
	     	    				$(target).css({'border-right-color': newColor});
	     	    		}
	     	    	}
	     	    	
	     	    	
	     	    	// Checkbox
	     	    	if($(target).is(':checkbox')) {
	     	    			
	 	    			var toggle = $(target).attr('id');
	 	    			
	 	    			// Set value to 0
	 	    			$(target).val('');
	 	    			
	 	    			// Check if checked and set to 1
	 	    			if(val == 1) {
	 	    				$('.' + toggle).fadeIn().parent().fadeIn();
	 	    				$(target).prop('checked', 'true').val('1').attr('data-stored', '1');
	 	    				
	 	    			}
	 	    			
	 	    			if(val == "" || val == 0) {
	 	    				
	 	    				$('.' + toggle).fadeOut().parent().fadeOut();
	 	    				$(target).prop('checked', false).val('0').attr('data-stored', '0');
	 	    			}
	 	    		}

					// Select
					if($(target).is('select')) {
						// Check if checked and set to 1
						
						if(val == "") {
							$(target + ' option[value="inherit"]').attr('selected', 1);
														
						}	else {
							$(target + ' option[value="'+ val + '"]').attr('selected', 1);
						}	
					
					}
					
					
						     	    	
	       	    	if(key == "framework_version") {
	     	    		$('#framework_version').val(val);
	     	    		$('.framework_list').removeClass('active');
	     	    		$('#'+val).addClass('active')
	     	    	}
	     	    	
	        	    if(key == "framework_files") {
	     	    		
	     	    		// Reset Framework files
	     	    		$('input.framework_files').removeAttr('checked').val(0);
	     	    		
	     	    		var files = val.split('_');
	     	    		
	     	    		$(files).each(function() {
	     	    			
	     	    			$('.active input[data-id="' + this + '"]').prop('checked', 'true').val(1);
	     	    		
	     	    		});	    		
	     	    	}
	     	  });
	     	  
	     	  $('.border-rule').each(function() {
	     	  		var rule = $(this);
	     	  		var widths = $(this).find('.border-widths-value').val();
	     	  		
	     	  		if(widths !=="") {
		     	  		
		     	  		widths = widths.split(' ');
		     	  		
		     	  		$(widths).each(function(i, width) {
		     	  			if(width !=="0") {
		     	  				$(rule).find('[data-key="' + i + '"]').addClass('active');
		     	  			}
		     	  		});
		     	  	}
	     	  });
	     	  
	     	  if(!$('#cssfile').hasClass('updated')) {
	     	 	 $('#compile_required').val('0');
	     	 }
					     	  	
		})
		.error(function(data) { 
		
			alert("There is an error your theme's saved data. Loading system defaults.");
		
		 });
		
		
	};			
})(jQuery);